Index: kern/sys_pipe.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sys_pipe.c,v
retrieving revision 1.82
diff -u -r1.82 sys_pipe.c
--- kern/sys_pipe.c	2001/06/15 20:45:01	1.82
+++ kern/sys_pipe.c	2001/07/04 02:54:15
@@ -248,13 +248,14 @@
 	caddr_t buffer;
 	int npages, error;
 
+	GIANT_REQUIRED;
+
 	npages = round_page(size)/PAGE_SIZE;
 	/*
 	 * Create an object, I don't like the idea of paging to/from
 	 * kernel_object.
 	 * XXX -- minor change needed here for NetBSD/OpenBSD VM systems.
 	 */
-	mtx_lock(&vm_mtx);
 	object = vm_object_allocate(OBJT_DEFAULT, npages);
 	buffer = (caddr_t) vm_map_min(kernel_map);
 
@@ -269,13 +270,11 @@
 
 	if (error != KERN_SUCCESS) {
 		vm_object_deallocate(object);
-		mtx_unlock(&vm_mtx);
 		return (ENOMEM);
 	}
 
 	/* free old resources if we're resizing */
 	pipe_free_kmem(cpipe);
-	mtx_unlock(&vm_mtx);
 	cpipe->pipe_buffer.object = object;
 	cpipe->pipe_buffer.buffer = buffer;
 	cpipe->pipe_buffer.size = size;
@@ -551,12 +550,13 @@
 	int i;
 	vm_offset_t addr, endaddr, paddr;
 
+	GIANT_REQUIRED;
+
 	size = (u_int) uio->uio_iov->iov_len;
 	if (size > wpipe->pipe_buffer.size)
 		size = wpipe->pipe_buffer.size;
 
 	endaddr = round_page((vm_offset_t)uio->uio_iov->iov_base + size);
-	mtx_lock(&vm_mtx);
 	addr = trunc_page((vm_offset_t)uio->uio_iov->iov_base);
 	for (i = 0; addr < endaddr; addr += PAGE_SIZE, i++) {
 		vm_page_t m;
@@ -567,7 +567,6 @@
 
 			for (j = 0; j < i; j++)
 				vm_page_unwire(wpipe->pipe_map.ms[j], 1);
-			mtx_unlock(&vm_mtx);
 			return (EFAULT);
 		}
 
@@ -599,7 +598,6 @@
 	pmap_qenter(wpipe->pipe_map.kva, wpipe->pipe_map.ms,
 		wpipe->pipe_map.npages);
 
-	mtx_unlock(&vm_mtx);
 /*
  * and update the uio data
  */
@@ -621,8 +619,9 @@
 	struct pipe *wpipe;
 {
 	int i;
+
+	GIANT_REQUIRED;
 
-	mtx_lock(&vm_mtx);
 	if (wpipe->pipe_map.kva) {
 		pmap_qremove(wpipe->pipe_map.kva, wpipe->pipe_map.npages);
 
@@ -636,7 +635,6 @@
 	}
 	for (i = 0; i < wpipe->pipe_map.npages; i++)
 		vm_page_unwire(wpipe->pipe_map.ms[i], 1);
-	mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -1167,8 +1165,8 @@
 pipe_free_kmem(cpipe)
 	struct pipe *cpipe;
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (cpipe->pipe_buffer.buffer != NULL) {
 		if (cpipe->pipe_buffer.size > PIPE_SIZE)
 			--nbigpipe;
@@ -1228,13 +1226,11 @@
 		/*
 		 * free resources
 		 */
-		mtx_lock(&vm_mtx);
 		pipe_free_kmem(cpipe);
 		/* XXX: erm, doesn't zalloc already have its own locks and
 		 * not need the giant vm lock?
 		 */
 		zfree(pipe_zone, cpipe);
-		mtx_unlock(&vm_mtx);
 	}
 }
 
Index: kern/sysv_shm.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sysv_shm.c,v
retrieving revision 1.61
diff -u -r1.61 sysv_shm.c
--- kern/sysv_shm.c	2001/05/30 03:28:59	1.61
+++ kern/sysv_shm.c	2001/07/04 02:54:15
@@ -187,7 +187,8 @@
 	struct shm_handle *shm_handle;
 	size_t size;
 
-	mtx_assert(&vm_mtx, MA_OWNED);		/* For vm_object_deallocate. */
+	GIANT_REQUIRED;
+
 	shm_handle = shmseg->shm_internal;
 	vm_object_deallocate(shm_handle->shm_object);
 	free((caddr_t)shm_handle, M_SHM);
@@ -207,8 +208,7 @@
 	int segnum, result;
 	size_t size;
 
-	/* For vm_map_remove and shm_deallocate_segment. */
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 
 	segnum = IPCID_TO_IX(shmmap_s->shmid);
 	shmseg = &shmsegs[segnum];
@@ -254,9 +254,7 @@
 			break;
 	if (i == shminfo.shmseg)
 		return EINVAL;
-	mtx_lock(&vm_mtx);
 	error = shm_delete_mapping(p, shmmap_s);
-	mtx_unlock(&vm_mtx);
 	return error;
 }
 
@@ -282,6 +280,8 @@
 	vm_size_t size;
 	int rv;
 
+	GIANT_REQUIRED;
+
 	if (!jail_sysvipc_allowed && jailed(p->p_ucred))
 		return (ENOSYS);
 
@@ -334,17 +334,14 @@
 	}
 
 	shm_handle = shmseg->shm_internal;
-	mtx_lock(&vm_mtx);
 	vm_object_reference(shm_handle->shm_object);
 	rv = vm_map_find(&p->p_vmspace->vm_map, shm_handle->shm_object,
 		0, &attach_va, size, (flags & MAP_FIXED)?0:1, prot, prot, 0);
 	if (rv != KERN_SUCCESS) {
-		mtx_unlock(&vm_mtx);
 		return ENOMEM;
 	}
 	vm_map_inherit(&p->p_vmspace->vm_map,
 		attach_va, attach_va + size, VM_INHERIT_SHARE);
-	mtx_unlock(&vm_mtx);
 
 	shmmap_s->va = attach_va;
 	shmmap_s->shmid = uap->shmid;
@@ -434,6 +431,8 @@
 	struct shmid_ds inbuf;
 	struct shmid_ds *shmseg;
 
+	GIANT_REQUIRED;
+
 	if (!jail_sysvipc_allowed && jailed(p->p_ucred))
 		return (ENOSYS);
 
@@ -470,9 +469,7 @@
 		shmseg->shm_perm.key = IPC_PRIVATE;
 		shmseg->shm_perm.mode |= SHMSEG_REMOVED;
 		if (shmseg->shm_nattch <= 0) {
-			mtx_lock(&vm_mtx);
 			shm_deallocate_segment(shmseg);
-			mtx_unlock(&vm_mtx);
 			shm_last_free = IPCID_TO_IX(uap->shmid);
 		}
 		break;
@@ -539,6 +536,8 @@
 	struct shmid_ds *shmseg;
 	struct shm_handle *shm_handle;
 
+	GIANT_REQUIRED;
+
 	if (uap->size < shminfo.shmmin || uap->size > shminfo.shmmax)
 		return EINVAL;
 	if (shm_nused >= shminfo.shmmni) /* Any shmids left? */
@@ -574,7 +573,6 @@
 	 * We make sure that we have allocated a pager before we need
 	 * to.
 	 */
-	mtx_lock(&vm_mtx);
 	if (shm_use_phys) {
 		shm_handle->shm_object =
 		    vm_pager_allocate(OBJT_PHYS, 0, size, VM_PROT_DEFAULT, 0);
@@ -584,7 +582,6 @@
 	}
 	vm_object_clear_flag(shm_handle->shm_object, OBJ_ONEMAPPING);
 	vm_object_set_flag(shm_handle->shm_object, OBJ_NOSPLIT);
-	mtx_unlock(&vm_mtx);
 
 	shmseg->shm_internal = shm_handle;
 	shmseg->shm_perm.cuid = shmseg->shm_perm.uid = cred->cr_uid;
@@ -679,8 +676,9 @@
 {
 	struct shmmap_state *shmmap_s;
 	int i;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);	/* For shm_delete_mapping. */
 	shmmap_s = (struct shmmap_state *)p->p_vmspace->vm_shm;
 	for (i = 0; i < shminfo.shmseg; i++, shmmap_s++)
 		if (shmmap_s->shmid != -1)
Index: kern/uipc_syscalls.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/uipc_syscalls.c,v
retrieving revision 1.94
diff -u -r1.94 uipc_syscalls.c
--- kern/uipc_syscalls.c	2001/06/24 12:27:30	1.94
+++ kern/uipc_syscalls.c	2001/07/04 02:54:15
@@ -1489,8 +1489,9 @@
 	struct sf_buf *sf;
 	struct vm_page *m;
 
+	GIANT_REQUIRED;
+
 	sf = dtosf(addr);
-	mtx_lock(&vm_mtx);
 	pmap_qremove((vm_offset_t)addr, 1);
 	m = sf->m;
 	vm_page_unwire(m, 0);
@@ -1501,7 +1502,6 @@
 	 */
 	if (m->wire_count == 0 && m->object == NULL)
 		vm_page_free(m);
-	mtx_unlock(&vm_mtx);
 	sf->m = NULL;
 	mtx_lock(&sf_freelist.sf_lock);
 	SLIST_INSERT_HEAD(&sf_freelist.sf_head, sf, free_list);
@@ -1536,6 +1536,8 @@
 	off_t off, xfsize, sbytes = 0;
 	int error = 0, s;
 
+	GIANT_REQUIRED;
+
 	vp = NULL;
 	/*
 	 * Do argument checking. Must be a regular file in, stream
@@ -1646,19 +1648,16 @@
 		 *
 		 *	Wait and loop if busy.
 		 */
-		mtx_lock(&vm_mtx);
 		pg = vm_page_lookup(obj, pindex);
 
 		if (pg == NULL) {
 			pg = vm_page_alloc(obj, pindex, VM_ALLOC_NORMAL);
 			if (pg == NULL) {
 				VM_WAIT;
-				mtx_unlock(&vm_mtx);
 				goto retry_lookup;
 			}
 			vm_page_wakeup(pg);
 		} else if (vm_page_sleep_busy(pg, TRUE, "sfpbsy")) {
-			mtx_unlock(&vm_mtx);
 			goto retry_lookup;
 		}
 
@@ -1683,7 +1682,6 @@
 			 * completes.
 			 */
 			vm_page_io_start(pg);
-			mtx_unlock(&vm_mtx);
 
 			/*
 			 * Get the page from backing store.
@@ -1702,7 +1700,6 @@
 			error = VOP_READ(vp, &auio, IO_VMIO | ((MAXBSIZE / bsize) << 16),
 			        p->p_ucred);
 			VOP_UNLOCK(vp, 0, p);
-			mtx_lock(&vm_mtx);
 			vm_page_flag_clear(pg, PG_ZERO);
 			vm_page_io_finish(pg);
 			if (error) {
@@ -1717,7 +1714,6 @@
 					vm_page_busy(pg);
 					vm_page_free(pg);
 				}
-				mtx_unlock(&vm_mtx);
 				sbunlock(&so->so_snd);
 				goto done;
 			}
@@ -1728,13 +1724,10 @@
 		 * Get a sendfile buf. We usually wait as long as necessary,
 		 * but this wait can be interrupted.
 		 */
-		mtx_unlock(&vm_mtx);
 		if ((sf = sf_buf_alloc()) == NULL) {
-			mtx_lock(&vm_mtx);
 			vm_page_unwire(pg, 0);
 			if (pg->wire_count == 0 && pg->object == NULL)
 				vm_page_free(pg);
-			mtx_unlock(&vm_mtx);
 			sbunlock(&so->so_snd);
 			error = EINTR;
 			goto done;
@@ -1744,10 +1737,8 @@
 		 * Allocate a kernel virtual page and insert the physical page
 		 * into it.
 		 */
-		mtx_lock(&vm_mtx);
 		sf->m = pg;
 		pmap_qenter(sf->kva, &pg, 1);
-		mtx_unlock(&vm_mtx);
 		/*
 		 * Get an mbuf header and set it up as having external storage.
 		 */
Index: kern/vfs_bio.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_bio.c,v
retrieving revision 1.282
diff -u -r1.282 vfs_bio.c
--- kern/vfs_bio.c	2001/05/24 07:22:21	1.282
+++ kern/vfs_bio.c	2001/07/04 02:54:15
@@ -281,8 +281,6 @@
  *	Called when a buffer is extended.  This function clears the B_CACHE
  *	bit if the newly extended portion of the buffer does not contain
  *	valid data.
- *
- *	must be called with vm_mtx held
  */
 static __inline__
 void
@@ -290,6 +288,8 @@
 		  vm_ooffset_t foff, vm_offset_t off, vm_offset_t size,
 		  vm_page_t m)
 {
+	GIANT_REQUIRED;
+
 	if (bp->b_flags & B_CACHE) {
 		int base = (foff + off) & PAGE_MASK;
 		if (vm_page_is_valid(m, base, size) == 0)
@@ -340,6 +340,8 @@
 	struct buf *bp;
 	int i;
 
+	GIANT_REQUIRED;
+
 	TAILQ_INIT(&bswlist);
 	LIST_INIT(&invalhash);
 	mtx_init(&buftimelock, "buftime lock", MTX_DEF);
@@ -428,14 +430,11 @@
  * from buf_daemon.
  */
 
-	mtx_lock(&vm_mtx);
 	bogus_offset = kmem_alloc_pageable(kernel_map, PAGE_SIZE);
 	bogus_page = vm_page_alloc(kernel_object,
 			((bogus_offset - VM_MIN_KERNEL_ADDRESS) >> PAGE_SHIFT),
 			VM_ALLOC_NORMAL);
 	cnt.v_wire_count++;
-	mtx_unlock(&vm_mtx);
-
 }
 
 /*
@@ -445,23 +444,19 @@
  *	buffer_map.
  *
  *	Since this call frees up buffer space, we call bufspacewakeup().
- *
- *	Must be called without the vm_mtx.
  */
 static void
 bfreekva(struct buf * bp)
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	if (bp->b_kvasize) {
 		++buffreekvacnt;
 		bufspace -= bp->b_kvasize;
-		mtx_lock(&vm_mtx);
 		vm_map_delete(buffer_map,
 		    (vm_offset_t) bp->b_kvabase,
 		    (vm_offset_t) bp->b_kvabase + bp->b_kvasize
 		);
-		mtx_unlock(&vm_mtx);
 		bp->b_kvasize = 0;
 		bufspacewakeup();
 	}
@@ -478,6 +473,8 @@
 	int s = splbio();
 	int old_qindex = bp->b_qindex;
 
+	GIANT_REQUIRED;
+
 	if (bp->b_qindex != QUEUE_NONE) {
 		KASSERT(BUF_REFCNT(bp) == 1, ("bremfree: bp %p not locked",bp));
 		TAILQ_REMOVE(&bufqueues[bp->b_qindex], bp, b_freelist);
@@ -789,6 +786,8 @@
 void
 bdwrite(struct buf * bp)
 {
+	GIANT_REQUIRED;
+
 	if (BUF_REFCNT(bp) == 0)
 		panic("bdwrite: buffer is not busy");
 
@@ -817,7 +816,6 @@
 		VOP_BMAP(bp->b_vp, bp->b_lblkno, NULL, &bp->b_blkno, NULL, NULL);
 	}
 
-	mtx_lock(&vm_mtx);
 	/*
 	 * Set the *dirty* buffer range based upon the VM system dirty pages.
 	 */
@@ -831,7 +829,6 @@
 	 * out on the next sync, or perhaps the cluster will be completed.
 	 */
 	vfs_clean_pages(bp);
-	mtx_unlock(&vm_mtx);
 	bqrelse(bp);
 
 	/*
@@ -985,15 +982,14 @@
  *	Release a busy buffer and, if requested, free its resources.  The
  *	buffer will be stashed in the appropriate bufqueue[] allowing it
  *	to be accessed later as a cache entity or reused for other purposes.
- *
- *	vm_mtx must be not be held.
  */
 void
 brelse(struct buf * bp)
 {
 	int s;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	KASSERT(!(bp->b_flags & (B_CLUSTER|B_PAGING)), ("brelse: inappropriate B_PAGING or B_CLUSTER bp %p", bp));
 
 	s = splbio();
@@ -1103,7 +1099,6 @@
 		resid = bp->b_bufsize;
 		foff = bp->b_offset;
 
-		mtx_lock(&vm_mtx);
 		for (i = 0; i < bp->b_npages; i++) {
 			int had_bogus = 0;
 
@@ -1115,12 +1110,10 @@
 			 * now.
 			 */
 			if (m == bogus_page) {
-				mtx_unlock(&vm_mtx);
 				VOP_GETVOBJECT(vp, &obj);
 				poff = OFF_TO_IDX(bp->b_offset);
 				had_bogus = 1;
 
-				mtx_lock(&vm_mtx);
 				for (j = i; j < bp->b_npages; j++) {
 					vm_page_t mtmp;
 					mtmp = bp->b_pages[j];
@@ -1154,14 +1147,11 @@
 
 		if (bp->b_flags & (B_INVAL | B_RELBUF))
 			vfs_vmio_release(bp);
-		mtx_unlock(&vm_mtx);
 
 	} else if (bp->b_flags & B_VMIO) {
 
 		if (bp->b_flags & (B_INVAL | B_RELBUF)) {
-			mtx_lock(&vm_mtx);
 			vfs_vmio_release(bp);
-			mtx_unlock(&vm_mtx);
 		}
 
 	}
@@ -1326,9 +1316,6 @@
 	splx(s);
 }
 
-/*
- * Must be called with vm_mtx held.
- */
 static void
 vfs_vmio_release(bp)
 	struct buf *bp;
@@ -1336,7 +1323,8 @@
 	int i;
 	vm_page_t m;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	for (i = 0; i < bp->b_npages; i++) {
 		m = bp->b_pages[i];
 		bp->b_pages[i] = NULL;
@@ -1372,8 +1360,6 @@
 		}
 	}
 	pmap_qremove(trunc_page((vm_offset_t) bp->b_data), bp->b_npages);
-
-	/* could drop vm_mtx here */
 	
 	if (bp->b_bufsize) {
 		bufspacewakeup();
@@ -1527,6 +1513,8 @@
 	int nqindex;
 	static int flushingbufs;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * We can't afford to block since we might be holding a vnode lock,
 	 * which may prevent system daemons from running.  We deal with
@@ -1646,9 +1634,7 @@
 		if (qindex == QUEUE_CLEAN) {
 			if (bp->b_flags & B_VMIO) {
 				bp->b_flags &= ~B_ASYNC;
-				mtx_lock(&vm_mtx);
 				vfs_vmio_release(bp);
-				mtx_unlock(&vm_mtx);
 			}
 			if (bp->b_vp)
 				brelvp(bp);
@@ -1771,14 +1757,12 @@
 
 			bfreekva(bp);
 
-			mtx_lock(&vm_mtx);
 			if (vm_map_findspace(buffer_map,
 				vm_map_min(buffer_map), maxsize, &addr)) {
 				/*
 				 * Uh oh.  Buffer map is to fragmented.  We
 				 * must defragment the map.
 				 */
-				mtx_unlock(&vm_mtx);
 				++bufdefragcnt;
 				defrag = 1;
 				bp->b_flags |= B_INVAL;
@@ -1795,7 +1779,6 @@
 				bufspace += bp->b_kvasize;
 				++bufreusecnt;
 			}
-			mtx_unlock(&vm_mtx);
 		}
 		bp->b_data = bp->b_kvabase;
 	}
@@ -1961,6 +1944,8 @@
 	vm_page_t m;
 	vm_ooffset_t off;
 
+	GIANT_REQUIRED;
+
 	if (incore(vp, blkno))
 		return 1;
 	if (vp->v_mount == NULL)
@@ -1973,7 +1958,6 @@
 		size = vp->v_mount->mnt_stat.f_iosize;
 	off = (vm_ooffset_t)blkno * (vm_ooffset_t)vp->v_mount->mnt_stat.f_iosize;
 
-	mtx_lock(&vm_mtx);
 	for (toff = 0; toff < vp->v_mount->mnt_stat.f_iosize; toff += tinc) {
 		m = vm_page_lookup(obj, OFF_TO_IDX(off + toff));
 		if (!m)
@@ -1985,11 +1969,9 @@
 		    (vm_offset_t) ((toff + off) & PAGE_MASK), tinc) == 0)
 			goto notinmem;
 	}
-	mtx_unlock(&vm_mtx);
 	return 1;
 
 notinmem:
-	mtx_unlock(&vm_mtx);
 	return (0);
 }
 
@@ -2003,8 +1985,6 @@
  *
  *	This routine is primarily used by NFS, but is generalized for the
  *	B_VMIO case.
- *
- *	Must be called with vm_mtx
  */
 static void
 vfs_setdirty(struct buf *bp) 
@@ -2012,7 +1992,7 @@
 	int i;
 	vm_object_t object;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Degenerate case - empty buffer
 	 */
@@ -2365,6 +2345,8 @@
 	int newbsize, mbsize;
 	int i;
 
+	GIANT_REQUIRED;
+
 	if (BUF_REFCNT(bp) == 0)
 		panic("allocbuf: buffer not busy");
 
@@ -2487,7 +2469,6 @@
 			 * DEV_BSIZE aligned existing buffer size.  Figure out
 			 * if we have to remove any pages.
 			 */
-			mtx_lock(&vm_mtx);
 			if (desiredpages < bp->b_npages) {
 				for (i = desiredpages; i < bp->b_npages; i++) {
 					/*
@@ -2508,7 +2489,6 @@
 				    (desiredpages << PAGE_SHIFT), (bp->b_npages - desiredpages));
 				bp->b_npages = desiredpages;
 			}
-			mtx_unlock(&vm_mtx);
 		} else if (size > bp->b_bcount) {
 			/*
 			 * We are growing the buffer, possibly in a 
@@ -2529,7 +2509,6 @@
 			vp = bp->b_vp;
 			VOP_GETVOBJECT(vp, &obj);
 
-			mtx_lock(&vm_mtx);
 			while (bp->b_npages < desiredpages) {
 				vm_page_t m;
 				vm_pindex_t pi;
@@ -2639,8 +2618,6 @@
 			    bp->b_npages
 			);
 			
-			mtx_unlock(&vm_mtx);
-
 			bp->b_data = (caddr_t)((vm_offset_t)bp->b_data | 
 			    (vm_offset_t)(bp->b_offset & PAGE_MASK));
 		}
@@ -2718,6 +2695,8 @@
 	int s, error;
 	void    (*biodone) __P((struct buf *));
 
+	GIANT_REQUIRED;
+
 	s = splbio();
 
 	KASSERT(BUF_REFCNT(bp) > 0, ("biodone: bp %p not busy %d", bp, BUF_REFCNT(bp)));
@@ -2778,7 +2757,6 @@
 		if (error) {
 			panic("biodone: no object");
 		}
-		mtx_lock(&vm_mtx);
 #if defined(VFS_BIO_DEBUG)
 		if (obj->paging_in_progress < bp->b_npages) {
 			printf("biodone: paging in progress(%d) < bp->b_npages(%d)\n",
@@ -2867,7 +2845,6 @@
 		}
 		if (obj)
 			vm_object_pip_wakeupn(obj, 0);
-		mtx_unlock(&vm_mtx);
 	}
 
 	/*
@@ -2891,15 +2868,14 @@
  * This routine is called in lieu of iodone in the case of
  * incomplete I/O.  This keeps the busy status for pages
  * consistant.
- *
- * vm_mtx should not be held
  */
 void
 vfs_unbusy_pages(struct buf * bp)
 {
 	int i;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	runningbufwakeup(bp);
 	if (bp->b_flags & B_VMIO) {
 		struct vnode *vp = bp->b_vp;
@@ -2907,7 +2883,6 @@
 
 		VOP_GETVOBJECT(vp, &obj);
 
-		mtx_lock(&vm_mtx);
 		for (i = 0; i < bp->b_npages; i++) {
 			vm_page_t m = bp->b_pages[i];
 
@@ -2924,7 +2899,6 @@
 			vm_page_io_finish(m);
 		}
 		vm_object_pip_wakeupn(obj, 0);
-		mtx_unlock(&vm_mtx);
 	}
 }
 
@@ -2935,15 +2909,13 @@
  *	range is restricted to the buffer's size.
  *
  *	This routine is typically called after a read completes.
- *
- *	vm_mtx should be held
  */
 static void
 vfs_page_set_valid(struct buf *bp, vm_ooffset_t off, int pageno, vm_page_t m)
 {
 	vm_ooffset_t soff, eoff;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Start and end offsets in buffer.  eoff - soff may not cross a
 	 * page boundry or cross the end of the buffer.  The end of the
@@ -2979,15 +2951,14 @@
  * Since I/O has not been initiated yet, certain buffer flags
  * such as BIO_ERROR or B_INVAL may be in an inconsistant state
  * and should be ignored.
- *
- * vm_mtx should not be held
  */
 void
 vfs_busy_pages(struct buf * bp, int clear_modify)
 {
 	int i, bogus;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
+	GIANT_REQUIRED;
+
 	if (bp->b_flags & B_VMIO) {
 		struct vnode *vp = bp->b_vp;
 		vm_object_t obj;
@@ -2997,7 +2968,6 @@
 		foff = bp->b_offset;
 		KASSERT(bp->b_offset != NOOFFSET,
 		    ("vfs_busy_pages: no buffer offset"));
-		mtx_lock(&vm_mtx);
 		vfs_setdirty(bp);
 
 retry:
@@ -3045,7 +3015,6 @@
 		}
 		if (bogus)
 			pmap_qenter(trunc_page((vm_offset_t)bp->b_data), bp->b_pages, bp->b_npages);
-		mtx_unlock(&vm_mtx);
 	}
 }
 
@@ -3056,15 +3025,14 @@
  *
  * Note that while we only really need to clean through to b_bcount, we
  * just go ahead and clean through to b_bufsize.
- *
- * should be called with vm_mtx held
  */
 static void
 vfs_clean_pages(struct buf * bp)
 {
 	int i;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	if (bp->b_flags & B_VMIO) {
 		vm_ooffset_t foff;
 
@@ -3132,9 +3100,6 @@
  *
  *	Note that while we only theoretically need to clear through b_bcount,
  *	we go ahead and clear through b_bufsize.
- *
- *	We'll get vm_mtx here for safety if processing a VMIO buffer.
- *	I don't think vm_mtx is needed, but we're twiddling vm_page flags.
  */
 
 void
@@ -3142,8 +3107,9 @@
 	int i, mask = 0;
 	caddr_t sa, ea;
 
+	GIANT_REQUIRED;
+
 	if ((bp->b_flags & (B_VMIO | B_MALLOC)) == B_VMIO) {
-		mtx_lock(&vm_mtx);
 		bp->b_flags &= ~B_INVAL;
 		bp->b_ioflags &= ~BIO_ERROR;
 		if( (bp->b_npages == 1) && (bp->b_bufsize < PAGE_SIZE) &&
@@ -3155,7 +3121,6 @@
 			}
 			bp->b_pages[0]->valid |= mask;
 			bp->b_resid = 0;
-			mtx_unlock(&vm_mtx);
 			return;
 		}
 		ea = sa = bp->b_data;
@@ -3183,7 +3148,6 @@
 			vm_page_flag_clear(bp->b_pages[i], PG_ZERO);
 		}
 		bp->b_resid = 0;
-		mtx_unlock(&vm_mtx);
 	} else {
 		clrbuf(bp);
 	}
@@ -3193,8 +3157,6 @@
  * vm_hold_load_pages and vm_hold_free_pages get pages into
  * a buffers address space.  The pages are anonymous and are
  * not associated with a file object.
- *
- * vm_mtx should not be held
  */
 static void
 vm_hold_load_pages(struct buf * bp, vm_offset_t from, vm_offset_t to)
@@ -3203,16 +3165,14 @@
 	vm_page_t p;
 	int index;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
+	GIANT_REQUIRED;
+
 	to = round_page(to);
 	from = round_page(from);
 	index = (from - trunc_page((vm_offset_t)bp->b_data)) >> PAGE_SHIFT;
 
-	mtx_lock(&vm_mtx);
 	for (pg = from; pg < to; pg += PAGE_SIZE, index++) {
-
 tryagain:
-
 		/*
 		 * note: must allocate system pages since blocking here
 		 * could intefere with paging I/O, no matter which
@@ -3234,7 +3194,6 @@
 		vm_page_wakeup(p);
 	}
 	bp->b_npages = index;
-	mtx_unlock(&vm_mtx);
 }
 
 void
@@ -3243,13 +3202,13 @@
 	vm_offset_t pg;
 	vm_page_t p;
 	int index, newnpages;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	from = round_page(from);
 	to = round_page(to);
 	newnpages = index = (from - trunc_page((vm_offset_t)bp->b_data)) >> PAGE_SHIFT;
 
-	mtx_lock(&vm_mtx);
 	for (pg = from; pg < to; pg += PAGE_SIZE, index++) {
 		p = bp->b_pages[index];
 		if (p && (index < bp->b_npages)) {
@@ -3265,7 +3224,6 @@
 		}
 	}
 	bp->b_npages = newnpages;
-	mtx_unlock(&vm_mtx);
 }
 
 
Index: kern/vfs_cluster.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_cluster.c,v
retrieving revision 1.110
diff -u -r1.110 vfs_cluster.c
--- kern/vfs_cluster.c	2001/05/24 07:22:23	1.110
+++ kern/vfs_cluster.c	2001/07/04 02:54:15
@@ -320,6 +320,8 @@
 	daddr_t bn;
 	int i, inc, j;
 
+	GIANT_REQUIRED;
+
 	KASSERT(size == vp->v_mount->mnt_stat.f_iosize,
 	    ("cluster_rbuild: size %ld != filesize %ld\n",
 	    size, vp->v_mount->mnt_stat.f_iosize));
@@ -433,7 +435,6 @@
 		BUF_KERNPROC(tbp);
 		TAILQ_INSERT_TAIL(&bp->b_cluster.cluster_head,
 			tbp, b_cluster.cluster_entry);
-		mtx_lock(&vm_mtx);
 		for (j = 0; j < tbp->b_npages; j += 1) {
 			vm_page_t m;
 			m = tbp->b_pages[j];
@@ -447,12 +448,10 @@
 			if ((m->valid & VM_PAGE_BITS_ALL) == VM_PAGE_BITS_ALL)
 				tbp->b_pages[j] = bogus_page;
 		}
-		mtx_unlock(&vm_mtx);
 		bp->b_bcount += tbp->b_bcount;
 		bp->b_bufsize += tbp->b_bufsize;
 	}
 
-	mtx_lock(&vm_mtx);
 	for(j=0;j<bp->b_npages;j++) {
 		if ((bp->b_pages[j]->valid & VM_PAGE_BITS_ALL) ==
 			VM_PAGE_BITS_ALL)
@@ -465,7 +464,6 @@
 
 	pmap_qenter(trunc_page((vm_offset_t) bp->b_data),
 		(vm_page_t *)bp->b_pages, bp->b_npages);
-	mtx_unlock(&vm_mtx);
 	return (bp);
 }
 
@@ -482,15 +480,15 @@
 	struct buf *nbp, *tbp;
 	int error = 0;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * Must propogate errors to all the components.
 	 */
 	if (bp->b_ioflags & BIO_ERROR)
 		error = bp->b_error;
 
-	mtx_lock(&vm_mtx);
 	pmap_qremove(trunc_page((vm_offset_t) bp->b_data), bp->b_npages);
-	mtx_unlock(&vm_mtx);
 	/*
 	 * Move memory from the large cluster buffer into the component
 	 * buffers and mark IO as done on these.
@@ -724,6 +722,8 @@
 	int totalwritten = 0;
 	int dbsize = btodb(size);
 
+	GIANT_REQUIRED;
+
 	while (len > 0) {
 		s = splbio();
 		/*
@@ -866,7 +866,6 @@
 					}
 				}
 					
-				mtx_lock(&vm_mtx);
 				for (j = 0; j < tbp->b_npages; j += 1) {
 					m = tbp->b_pages[j];
 					vm_page_io_start(m);
@@ -877,7 +876,6 @@
 						bp->b_npages++;
 					}
 				}
-				mtx_unlock(&vm_mtx);
 			}
 			bp->b_bcount += size;
 			bp->b_bufsize += size;
@@ -896,10 +894,8 @@
 				tbp, b_cluster.cluster_entry);
 		}
 	finishcluster:
-		mtx_lock(&vm_mtx);
 		pmap_qenter(trunc_page((vm_offset_t) bp->b_data),
 			(vm_page_t *) bp->b_pages, bp->b_npages);
-		mtx_unlock(&vm_mtx);
 		if (bp->b_bufsize > bp->b_kvasize)
 			panic(
 			    "cluster_wbuild: b_bufsize(%ld) > b_kvasize(%d)\n",
Index: kern/vfs_default.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_default.c,v
retrieving revision 1.53
diff -u -r1.53 vfs_default.c
--- kern/vfs_default.c	2001/05/23 19:51:12	1.53
+++ kern/vfs_default.c	2001/07/04 02:54:15
@@ -527,6 +527,8 @@
 	vm_object_t object;
 	int error = 0;
 
+	GIANT_REQUIRED;
+
 	if (!vn_isdisk(vp, NULL) && vn_canvmio(vp) == FALSE)
 		return (0);
 
@@ -535,7 +537,6 @@
 		if (vp->v_type == VREG || vp->v_type == VDIR) {
 			if ((error = VOP_GETATTR(vp, &vat, cred, p)) != 0)
 				goto retn;
-			mtx_lock(&vm_mtx);
 			object = vnode_pager_alloc(vp, vat.va_size, 0, 0);
 		} else if (devsw(vp->v_rdev) != NULL) {
 			/*
@@ -543,7 +544,6 @@
 			 * for a disk vnode.  This should be fixed, but doesn't
 			 * cause any problems (yet).
 			 */
-			mtx_lock(&vm_mtx);
 			object = vnode_pager_alloc(vp, IDX_TO_OFF(INT_MAX), 0, 0);
 		} else {
 			goto retn;
@@ -553,21 +553,14 @@
 		 * that the object is associated with the vp.
 		 */
 		object->ref_count--;
-		mtx_unlock(&vm_mtx);
 		vp->v_usecount--;
 	} else {
-		/*
-		 * XXX: safe to hold vm mutex through VOP_UNLOCK?
-		 */
-		mtx_lock(&vm_mtx);
 		if (object->flags & OBJ_DEAD) {
 			VOP_UNLOCK(vp, 0, p);
-			msleep(object, VM_OBJECT_MTX(object), PVM, "vodead", 0);
-			mtx_unlock(&vm_mtx);
+			tsleep(object, PVM, "vodead", 0);
 			vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, p);
 			goto retry;
 		}
-		mtx_unlock(&vm_mtx);
 	}
 
 	KASSERT(vp->v_object != NULL, ("vfs_object_create: NULL object"));
@@ -586,10 +579,11 @@
 	struct vnode *vp = ap->a_vp;
 	vm_object_t obj = vp->v_object;
 
+	GIANT_REQUIRED;
+
 	if (vp->v_object == NULL)
 		return (0);
 
-	mtx_lock(&vm_mtx);
 	if (obj->ref_count == 0) {
 		/*
 		 * vclean() may be called twice. The first time
@@ -604,7 +598,6 @@
 		 */
 		vm_pager_deallocate(obj);
 	}
-	mtx_unlock(&vm_mtx);
 	return (0);
 }
 
Index: kern/vfs_subr.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_subr.c,v
retrieving revision 1.314
diff -u -r1.314 vfs_subr.c
--- kern/vfs_subr.c	2001/06/28 04:05:54	1.314
+++ kern/vfs_subr.c	2001/07/04 02:54:15
@@ -711,7 +711,7 @@
 	int s, error;
 	vm_object_t object;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
+	GIANT_REQUIRED;
 
 	if (flags & V_SAVE) {
 		s = splbio();
@@ -799,10 +799,8 @@
 	 */
 	mtx_lock(&vp->v_interlock);
 	if (VOP_GETVOBJECT(vp, &object) == 0) {
-		mtx_lock(&vm_mtx);
 		vm_object_page_remove(object, 0, 0,
 			(flags & V_SAVE) ? TRUE : FALSE);
-		mtx_unlock(&vm_mtx);
 	}
 	mtx_unlock(&vp->v_interlock);
 
@@ -1136,8 +1134,6 @@
  * Also sets B_PAGING flag to indicate that vnode is not fully associated
  * with the buffer.  i.e. the bp has not been linked into the vnode or
  * ref-counted.
- *
- * Doesn't block, only vnode seems to need a lock.
  */
 void
 pbgetvp(vp, bp)
@@ -1559,8 +1555,9 @@
 	struct vnode *vp;
 {
 	struct proc *p = curproc;	/* XXX */
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&Giant, MA_OWNED);
 	KASSERT(vp != NULL, ("vput: null vp"));
 	mtx_lock(&vp->v_interlock);
 	/* Skip this v_writecount check if we're going to panic below. */
@@ -2363,6 +2360,8 @@
 	struct vm_object *obj;
 	int anyio, tries;
 
+	GIANT_REQUIRED;
+
 	tries = 5;
 loop:
 	anyio = 0;
@@ -2394,11 +2393,9 @@
 			if (!vget(vp,
 				LK_INTERLOCK | LK_EXCLUSIVE | LK_RETRY | LK_NOOBJ, curproc)) {
 				if (VOP_GETVOBJECT(vp, &obj) == 0) {
-					mtx_lock(&vm_mtx);
 					vm_object_page_clean(obj, 0, 0,
 					    flags == MNT_WAIT ?
 					    OBJPC_SYNC : OBJPC_NOSYNC);
-					mtx_unlock(&vm_mtx);
 					anyio = 1;
 				}
 				vput(vp);
@@ -2427,8 +2424,7 @@
 	struct proc *p;
 	struct ucred *cred;
 {
-
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
+	GIANT_REQUIRED;
 	return (VOP_CREATEVOBJECT(vp, cred, p));
 }
 
Index: kern/vfs_syscalls.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_syscalls.c,v
retrieving revision 1.194
diff -u -r1.194 vfs_syscalls.c
--- kern/vfs_syscalls.c	2001/06/06 23:34:38	1.194
+++ kern/vfs_syscalls.c	2001/07/04 02:54:15
@@ -2763,6 +2763,8 @@
 	vm_object_t obj;
 	int error;
 
+	GIANT_REQUIRED;
+
 	if ((error = getvnode(p->p_fd, SCARG(uap, fd), &fp)) != 0)
 		return (error);
 	vp = (struct vnode *)fp->f_data;
@@ -2770,9 +2772,7 @@
 		return (error);
 	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, p);
 	if (VOP_GETVOBJECT(vp, &obj) == 0) {
-		mtx_lock(&vm_mtx);
 		vm_object_page_clean(obj, 0, 0, 0);
-		mtx_unlock(&vm_mtx);
 	}
 	error = VOP_FSYNC(vp, fp->f_cred, MNT_WAIT, p);
 #ifdef SOFTUPDATES
Index: nfs/nfs_bio.c
===================================================================
RCS file: /home/ncvs/src/sys/nfs/nfs_bio.c,v
retrieving revision 1.95
diff -u -r1.95 nfs_bio.c
--- nfs/nfs_bio.c	2001/05/23 22:26:05	1.95
+++ nfs/nfs_bio.c	2001/07/04 02:54:16
@@ -111,6 +111,8 @@
 	struct nfsmount *nmp;
 	vm_page_t *pages;
 
+	GIANT_REQUIRED;
+
 	vp = ap->a_vp;
 	p = curproc;				/* XXX */
 	cred = curproc->p_ucred;		/* XXX */
@@ -118,7 +120,6 @@
 	pages = ap->a_m;
 	count = ap->a_count;
 
-	mtx_assert(&Giant, MA_OWNED);
 	if (vp->v_object == NULL) {
 		printf("nfs_getpages: called with non-merged cache vnode??\n");
 		return VM_PAGER_ERROR;
@@ -126,9 +127,7 @@
 
 	if ((nmp->nm_flag & NFSMNT_NFSV3) != 0 &&
 	    (nmp->nm_state & NFSSTA_GOTFSINFO) == 0) {
-		mtx_unlock(&vm_mtx);
 		(void)nfs_fsinfo(nmp, vp, cred, p);
-		mtx_lock(&vm_mtx);
 	}
 
 	npages = btoc(count);
@@ -172,9 +171,7 @@
 	uio.uio_rw = UIO_READ;
 	uio.uio_procp = p;
 
-	mtx_unlock(&vm_mtx);
 	error = nfs_readrpc(vp, &uio, cred);
-	mtx_lock(&vm_mtx);
 	pmap_qremove(kva, npages);
 
 	relpbuf(bp, &nfs_pbuf_freecnt);
@@ -274,6 +271,8 @@
 	struct nfsnode *np;
 	vm_page_t *pages;
 
+	GIANT_REQUIRED;
+
 	vp = ap->a_vp;
 	np = VTONFS(vp);
 	p = curproc;				/* XXX */
@@ -285,12 +284,11 @@
 	npages = btoc(count);
 	offset = IDX_TO_OFF(pages[0]->pindex);
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
+
 	if ((nmp->nm_flag & NFSMNT_NFSV3) != 0 &&
 	    (nmp->nm_state & NFSSTA_GOTFSINFO) == 0) {
-		mtx_unlock(&vm_mtx);
 		(void)nfs_fsinfo(nmp, vp, cred, p);
-		mtx_lock(&vm_mtx);
 	}
 
 	for (i = 0; i < npages; i++) {
@@ -331,9 +329,7 @@
 	else
 	    iomode = NFSV3WRITE_FILESYNC;
 
-	mtx_unlock(&vm_mtx);
 	error = nfs_writerpc(vp, &uio, cred, &iomode, &must_commit);
-	mtx_lock(&vm_mtx);
 
 	pmap_qremove(kva, npages);
 	relpbuf(bp, &nfs_pbuf_freecnt);
@@ -345,9 +341,7 @@
 			vm_page_undirty(pages[i]);
 		}
 		if (must_commit) {
-			mtx_unlock(&vm_mtx);
 			nfs_clearcommit(vp->v_mount);
-			mtx_lock(&vm_mtx);
 		}
 	}
 	return rtvals[0];
@@ -770,6 +764,8 @@
 	int n, on, error = 0, iomode, must_commit;
 	int haverslock = 0;
 
+	GIANT_REQUIRED;
+
 #ifdef DIAGNOSTIC
 	if (uio->uio_rw != UIO_WRITE)
 		panic("nfs_write mode");
@@ -1091,9 +1087,7 @@
 				bp->b_dirtyoff = on;
 				bp->b_dirtyend = on + n;
 			}
-			mtx_lock(&vm_mtx);
 			vfs_bio_set_validclean(bp, on, n);
-			mtx_unlock(&vm_mtx);
 		}
 
 		/*
Index: nfs/nfs_subs.c
===================================================================
RCS file: /home/ncvs/src/sys/nfs/nfs_subs.c,v
retrieving revision 1.102
diff -u -r1.102 nfs_subs.c
--- nfs/nfs_subs.c	2001/06/28 04:08:20	1.102
+++ nfs/nfs_subs.c	2001/07/04 02:54:16
@@ -2138,9 +2138,9 @@
 	register struct buf *bp, *nbp;
 	int s;
 
+	GIANT_REQUIRED;
+
 	s = splbio();
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 	mtx_lock(&mntvnode_mtx);
 loop:
 	for (vp = LIST_FIRST(&mp->mnt_vnodelist); vp; vp = nvp) {
Index: pc98/i386/machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/pc98/i386/machdep.c,v
retrieving revision 1.224
diff -u -r1.224 machdep.c
--- pc98/i386/machdep.c	2001/06/29 11:10:37	1.224
+++ pc98/i386/machdep.c	2001/07/04 02:54:16
@@ -276,7 +276,6 @@
 	/*
 	 * Good {morning,afternoon,evening,night}.
 	 */
-	mtx_lock(&vm_mtx);
 	earlysetcpuclass();
 	startrtclock();
 	printcpuinfo();
@@ -410,7 +409,6 @@
 	exec_map = kmem_suballoc(kernel_map, &minaddr, &maxaddr,
 				(16*(ARG_MAX+(PAGE_SIZE*3))));
 
-	mtx_unlock(&vm_mtx);
 	/*
 	 * XXX: Mbuf system machine-specific initializations should
 	 *      go here, if anywhere.
@@ -2116,6 +2114,8 @@
 	if (!has_f00f_bug)
 		return;
 
+	GIANT_REQUIRED;
+
 	printf("Intel Pentium detected, installing workaround for F00F bug\n");
 
 	r_idt.rd_limit = sizeof(idt0) - 1;
@@ -2131,11 +2131,9 @@
 	r_idt.rd_base = (int)new_idt;
 	lidt(&r_idt);
 	idt = new_idt;
-	mtx_lock(&vm_mtx);
 	if (vm_map_protect(kernel_map, tmp, tmp + PAGE_SIZE,
 			   VM_PROT_READ, FALSE) != KERN_SUCCESS)
 		panic("vm_map_protect failed");
-	mtx_unlock(&vm_mtx);
 	return;
 }
 #endif /* defined(I586_CPU) && !NO_F00F_HACK */
